<?php
/*
Plugin Name: Better-Wiki-Link
Plugin URI: http://www.bass-blogger.de/wordpress-wikipedia-plugin/
Description: This PlugIn will link every [[text]] or [[alt.text|link]] with the the appropriate wiki-system. (Option-page in english and german)
Version: 1.2.2
Author: Bass-Blogger
Author URI: http://www.bass-blogger.de/

License:

    Copyright 2008 Tim Charzinski  (email : tim@bass-blogger.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/
$better_link_version="1.2.2";

////////////////////////////////////////////////////////////////////////////////////////////////////////

/* Bedingungen ermitteln*/
if ("blank" == get_option("betterwiki_link_target")){$betterwiki_target="_blank";};
if ("top" == get_option("betterwiki_link_target")){$betterwiki_target="_top";};

if ("wiki-de" == get_option("betterwiki_link_wiki")){$betterwiki_url='de.wikipedia.org/wiki/';};
if ("wiki-en" == get_option("betterwiki_link_wiki")){$betterwiki_url='en.wikipedia.org/wiki/';};
if ("wiki-fr" == get_option("betterwiki_link_wiki")){$betterwiki_url='fr.wikipedia.org/wiki/';};
if ("wiki-it" == get_option("betterwiki_link_wiki")){$betterwiki_url='it.wikipedia.org/wiki/';};
if ("wiki-ja" == get_option("betterwiki_link_wiki")){$betterwiki_url='ja.wikipedia.org/wiki/';};
if ("wiki-nl" == get_option("betterwiki_link_wiki")){$betterwiki_url='nl.wikipedia.org/wiki/';};
if ("wiki-pl" == get_option("betterwiki_link_wiki")){$betterwiki_url='pl.wikipedia.org/wiki/';};
if ("wiki-pt" == get_option("betterwiki_link_wiki")){$betterwiki_url='pt.wikipedia.org/wiki/';};
if ("wiki-ru" == get_option("betterwiki_link_wiki")){$betterwiki_url='ru.wikipedia.org/wiki/';};
if ("wiki-sv" == get_option("betterwiki_link_wiki")){$betterwiki_url='sv.wikipedia.org/wiki/';};
if ("wiki-es" == get_option("betterwiki_link_wiki")){$betterwiki_url='es.wikipedia.org/wiki/';};
if ("google" == get_option("betterwiki_link_wiki")){$betterwiki_url='www.google.com/search?q=';};

if ("follow" == get_option("betterwiki_link_follow")){$betterwiki_rel="follow";};
if ("nofollow" == get_option("betterwiki_link_follow")){$betterwiki_rel="nofollow";};

if ("1"  == get_option("betterwiki_link_alt_wiki_opt")){
$betterwiki_url =get_option(betterwiki_link_alt_wiki_url);
};

////////////////////////////////////////////////////////////////////////////////////////////////////////


class basswikilink {

  function basswikilink() {
     add_filter('the_content', array(&$this, 'basswiki'));
  }

  function basswiki($content) { 
global $betterwiki_target,$betterwiki_rel,$betterwiki_url,$betterwiki_alt_url;

$pattern2 = "!\[\[([^\]]*)\|(.*)\]\]!isU";
$content = preg_replace($pattern2,"<a href=\"http://$betterwiki_url$1\" target=\"$betterwiki_target\" rel=\"$betterwiki_rel\">$2</a>",$content);


$pattern = "!\[\[(.*)\]\]!isU";
$content = preg_replace($pattern,"<a href=\"http://$betterwiki_url$1\" target=\"$betterwiki_target\" rel=\"$betterwiki_rel\">$1</a>",$content);

	return $content;
  }

}

$sign &= new basswikilink();
////////////////////////////////////////////////////////////////////////////////////////////////////////

function betterwiki_link_option_page() {
global $betterwiki_target,$betterwiki_rel,$betterwiki_url,$betterwiki_alt_url,$better_link_version;
$betterwiki_alt_url =get_option(betterwiki_link_alt_wiki_url);

if ("en"  == get_option("betterwiki_link_language")){
$better_link_text_language ="Language";
$better_link_text_link ="Linking";
$better_link_text_targetwiki ="preinstalled Wiki";
$better_link_text_altwiki ="alternative Wiki";
$better_link_text_target ="Open Link";
$better_link_text_opening ="This PlugIn will link every wiki-like tagged [[<strong>Word</strong>]] or [[<strong>target|word</strong>]] with the corresponding site of any wiki.";
$better_link_text_save ="Update Options";
$better_link_text_donate ="While this software is being provided <strong>free to use</strong>, it takes considerable time to develop and support. If you do find it particularly useful then <strong>consider <a href=\"http://www.amazon.de/gp/registry/PCQGMRMPPNLJ\" target=_blank>donating</a></strong>";
$better_link_text_donate_pic ="donate.jpg";
$better_link_text_yes ="yes";
$better_link_text_no ="no";
$better_link_link_link_follow ="searchengines will follow";
$better_link_link_link_nofollow ="searchengines will ignore";
$better_link_link_target_blank ="in new browser-tab (_blank)";
$better_link_link_target_top ="in same browser-tab (_top)";
$better_link_link_target_example ="<em>without http:// <br><strong>some examples:</strong> <ul><li>www.amazon.com/s/ref=nb_ss_gw/002-2095015-0616029?url=search-alias%3Daps&field-keywords=</li><li>search.ebay.com/search/search.dll?from=R40&_trksid=m37&satitle=</li><li>www.youtube.com/results?search_query=</li></ul></em>";
};

if ("de"  == get_option("betterwiki_link_language")){
$better_link_text_language ="Sprache";
$better_link_text_link ="Verlinkung";
$better_link_text_targetwiki ="Ziel-Wiki";
$better_link_text_altwiki ="altern. Wiki-System";
$better_link_text_target ="Neuen Link öffnen";
$better_link_text_opening ="Das PlugIn unterlegt im WYSIWYG-Editor alle [[<strong>Worte</strong>]] mit einem Link zu der entsprechenden Seite eines beliebigen Wikis.";
$better_link_text_save ="Einstellung speichern";
$better_link_text_donate ="Dieses PlugIn darf <em>kostenlos</em> in jeder <strong>privaten</strong> Wordpress-Installation eingesetzt werden! <br>Gewerbliche Betreiber werden um ein <a href=\"http://www.amazon.de/gp/registry/PCQGMRMPPNLJ\" target=_blank rel=nofollow><strong>kleine Spende</strong></a> gebeten.";
$better_link_text_donate_pic ="spende.jpg";
$better_link_text_yes ="ja";
$better_link_text_no ="nein";
$better_link_link_link_follow ="Suchmaschinen verfolgen Links";
$better_link_link_link_nofollow ="Suchmaschinen ignorieren Links";
$better_link_link_target_blank ="im neuem Browserfenster (_blank)";
$better_link_link_target_top ="im selben Browserfenster (_top)";
$better_link_link_target_example ="<em>ohne http:// <br><strong>zum Beispiel:</strong> <ul><li>www.amazon.de/s/ref=nb_ss_gw/002-2095015-0616029?url=search-alias%3Daps&field-keywords=</li><li>search.ebay.de/search/search.dll?from=R40&_trksid=m37&satitle=</li><li>www.youtube.com/results?search_query=</li></ul></em>";
};

?>

<!-- Start Optionen im Adminbereich (xhtml, außerhalb PHP) -->
        <div class="wrap">
          <h2>Better-[[Wiki]]-Link Options Ver. <?=$better_link_version;?></h2>
<p><?=$better_link_text_opening;?></p>
<hr>
          <p class=submit>
            <input type="submit" value="<?=$better_link_text_save;?>" />
	  </p>

<p>
<form name="better_wiki_form" method="post" action="<?=$location ?>">
<input name="action" value="insert" type="hidden" />
<table width="100%" border="0" cellspacing="0" cellpadding="6">

   	<tr valign="top"><td width="25%" align="right">
	<b><?=$better_link_text_language;?>:</b>
	</td><td align="left"><select name="betterwiki_link_language">
            <option value="en" <?php if ("en" == get_option("betterwiki_link_language")) { echo "selected";}; ?>>English</option>
            <option value="de" <?php if ("de" == get_option("betterwiki_link_language")) { echo "selected";}; ?>>Deutsch</option>
          </select></td></tr>

       
<tr valign="top"><td width="25%" align="right">
	<b><?=$better_link_text_targetwiki;?>:</b>
	</td><td align="left"><select name="betterwiki_link_wiki">
<option value="google" <?php if ("google" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Google-Search</option>
            <option value="wiki-en" <?php if ("wiki-en" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (EN)</option>
            <option value="wiki-de" <?php if ("wiki-de" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (DE)</option>
            <option value="wiki-fr" <?php if ("wiki-fr" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Français)</option>
            <option value="wiki-ja" <?php if ("wiki-ja" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (日本語)</option>
            <option value="wiki-nl" <?php if ("wiki-nl" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Nederlands)</option>
            <option value="wiki-pl" <?php if ("wiki-pl" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Polski)</option>
            <option value="wiki-pt" <?php if ("wiki-pt" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Português)</option>
            <option value="wiki-ru" <?php if ("wiki-ru" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Русский)</option>
            <option value="wiki-sv" <?php if ("wiki-sv" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Svenska)</option>
            <option value="wiki-es" <?php if ("wiki-es" == get_option("betterwiki_link_wiki")) { echo "selected";}; ?>>Wikipedia (Español)</option>
          </select></td></tr>          

<tr valign="top"><td width="25%" align="right">
	<b><?=$better_link_text_altwiki;?>:</b>
	</td><td align="left">
<input type="radio" name="betterwiki_link_alt_wiki_opt" value="1" <?php if ("1" == get_option("betterwiki_link_alt_wiki_opt")) { echo "checked";}; ?>><?=$better_link_text_yes;?> 
<input type="radio" name="betterwiki_link_alt_wiki_opt" value="0" <?php if ("0" == get_option("betterwiki_link_alt_wiki_opt")) { echo "checked";}; ?>><?=$better_link_text_no;?> 
<br>
            <INPUT type="text" name="betterwiki_link_alt_wiki_url" SIZE=60 value="<?php echo $betterwiki_alt_url;?>"><br>

<?=$better_link_link_target_example;?>
            </td></tr> 

   	<tr valign="top"><td width="25%" align="right">
	<b><?=$better_link_text_link;?>:</b>
	</td><td align="left"><select name="betterwiki_link_follow">
            <option value="follow" <?php if ("follow" == get_option("betterwiki_link_follow")) { echo "selected";}; ?>><?=$better_link_link_link_follow;?> (follow)</option>
            <option value="nofollow" <?php if ("nofollow" == get_option("betterwiki_link_follow")) { echo "selected";}; ?>><?=$better_link_link_link_nofollow;?> (nofollow)</option>
          </select></td></tr>

<tr valign="top"><td width="25%" align="right">
	<b><?=$better_link_text_target;?>:</b>
	</td><td align="left"><select name="betterwiki_link_target">
            <option value="top" <?php if ("top" == get_option("betterwiki_link_target")) { echo "selected";}; ?>><?=$better_link_link_target_top;?></option>
            <option value="blank" <?php if ("blank" == get_option("betterwiki_link_target")) { echo "selected";}; ?>><?=$better_link_link_target_blank;?></option>
          </select></td></tr> 
        
        </table>
          <p class=submit>
            <input type="submit" value="<?=$better_link_text_save;?>" />
	  </p>

</form>

</div>
<div class="wrap">
<p>
<hr>
<p>
<a href="http://www.amazon.de/gp/registry/PCQGMRMPPNLJ" target=_blank rel=nofollow><img src="http://www.bass-blogger.de/images/<?=$better_link_text_donate_pic;?>" border=0 align=right></a>
<?=$better_link_text_donate;?>
<br><br>
<p>
<hr>
<p>
Mein spezieller Dank  geht an <a href="http://www.bdsa.de">Olaf Felten</a> und <a href="http://www.interessante-zeiten.de/">Henning Rosenhagen</a> für Ihr wertvolles Wissen um Wordpress-PlugIns. Und natürlich Delta, der mich mit seinem Wikipedia-PlugIn auf die Idee gebracht hat, sowie <a href="http://www.bassic.de">Sam</a>, dem Macher von www.basserwisser.de.
</p>
<hr>          
        <p class="copyright">Better-Wiki-Link &copy; by <a href="http://www.bass-blogger.de/wordpress-wikipedia-plugin/">Tim Charzinski</a> 2008</p>
        </div>

<?php
} // Ende Funktion betterwiki_link_option_page()


// Adminmenu Optionen erweitern

function betterwiki_link_add_menu() {
        add_option("betterwiki_link_follow","follow"); 
        add_option("betterwiki_link_wiki","wiki-de"); 
        add_option("betterwiki_link_target","blank"); 
        add_option("betterwiki_link_alt_wiki_opt","0"); 
        add_option("betterwiki_link_alt_wiki_url","-"); 
        add_option("betterwiki_link_language","en"); 
//optionenseite hinzufügen
        add_options_page('Better-Wiki Optionen', 'Better-Wiki-Link', 9, __FILE__, 'betterwiki_link_option_page'); 
}

if ('insert' == $HTTP_POST_VARS['action'])
{
    update_option("betterwiki_link_follow",$HTTP_POST_VARS['betterwiki_link_follow']);
    update_option("betterwiki_link_wiki",$HTTP_POST_VARS['betterwiki_link_wiki']);
    update_option("betterwiki_link_target",$HTTP_POST_VARS['betterwiki_link_target']);
    update_option("betterwiki_link_alt_wiki_opt",$HTTP_POST_VARS['betterwiki_link_alt_wiki_opt']);
    update_option("betterwiki_link_alt_wiki_url",$HTTP_POST_VARS['betterwiki_link_alt_wiki_url']);
    update_option("betterwiki_link_language",$HTTP_POST_VARS['betterwiki_link_language']);

}
///////////////////////////////////////////////////////////////////////////////////////////////////////
	


////////////////////////////////////////////////////////////////////////////////////////////////////////
# Registrieren der WordPress-Hooks
add_action('admin_menu', 'betterwiki_link_add_menu');
?>